package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.Feedback;
import com.izouma.awesomeadmin.service.FeedbackService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/feedback")
public class FeedbackController {

    @Autowired
    private FeedbackService feedbackService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(Feedback record) {
        List<Feedback> pp = feedbackService.getFeedbackList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getFeedback", method = RequestMethod.GET)
    @ResponseBody
    public Result getFeedback(@RequestParam(required = false, value = "id") String id) {
        Feedback data = feedbackService.getFeedbackById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(Feedback record) {
        Feedback data = feedbackService.getFeedback(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, Feedback record) {
        Map<String, Object> result = new HashMap<>();

        List<Feedback> pp =feedbackService.getFeedbackByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(Feedback record) {
        boolean num = feedbackService.createFeedback(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateFeedback(Feedback record) {
        boolean num = feedbackService.updateFeedback(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteFeedback(@RequestParam(required = true, value = "id") String id) {

        boolean num = feedbackService.deleteFeedback(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, Feedback record) throws Exception {

    List<Feedback> feedbacks = feedbackService.getFeedbackList(record);


        String sheetName = "feedback";
        String titleName = "反馈数据表";
        String fileName = "反馈表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "用户" ,   "姓名" ,   "电话" ,   "描述" ,   "图片"  };
        String[][] dataList = new String[feedbacks.size()][11];

        for (int i = 0; i < feedbacks.size(); i++) {

                        dataList[i][0] = String.valueOf(feedbacks.get(i).getId());
                        dataList[i][1] = String.valueOf(feedbacks.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(feedbacks.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(feedbacks.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(feedbacks.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(feedbacks.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(feedbacks.get(i).getUserId());
                        dataList[i][7] = String.valueOf(feedbacks.get(i).getUserName());
                        dataList[i][8] = String.valueOf(feedbacks.get(i).getTelephone());
                        dataList[i][9] = String.valueOf(feedbacks.get(i).getRemark());
                        dataList[i][10] = String.valueOf(feedbacks.get(i).getImage());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

